(let*
  (
    (font (get-font "lucidasans-bold-12"))
    (font-colors (list "black" "white"))
    
	(title-width
	   (lambda (w)
	      (let
		 ((w-width (car (window-dimensions w))))
		 (max 0 (+ 20 (min (- w-width 74)
                 (text-width (window-name w))))))))
	
	(half-title-width
	     (lambda (w)
	         (/ (title-width w) 2)))
			
	(title-position
	     (lambda (w)
		 (- (/ (car (window-dimensions w)) 2) 
		 (half-title-width w)) ))                 
 
        (update-title-width
	      (lambda (w)
	         (if (eq (window-get w 'current-frame-style) 'whistler-II)
		     (rebuild-frame w))))
	
	
	(title-images (list (set-image-border
	                    (make-image "title-bar-inactive.png") 10 10 0 0)
                            (set-image-border
			    (make-image "title-bar-active.png")10 10 0 0)))

     	(iconify-images (list (make-image "iconify-normal.png")
			      nil nil
                              (make-image "iconify-clicked.png")))

     	(maximize-images (list (make-image "maximize-normal.png")
                               nil nil
  	 		       (make-image "maximize-clicked.png")))

     	(close-images (list (make-image "close-normal.png")
			    nil nil
                            (make-image "close-clicked.png")))

         (menu-images (list (make-image "menu-normal.png")
	                     nil nil
			     (make-image "menu-clicked.png")))

     	(border-bottom (make-image "border_bottom.png"))
     	(border-right (make-image "border_right.png"))
     	(border-left (make-image "border_left.png"))

	(corner-bl-1 (make-image "corner_bottom_left_2.png"))
	(corner-br-1 (make-image "corner_bottom_right_2.png"))
				

     	(frame `(

		((background . ,title-images)
		 (top-edge . -22)
		 (left-edge . 20)
		 (right-edge . 53)
		 (foreground . ,font-colors)
		 (font . ,font)
		 (text . ,window-name)
                 (x-justify . center)
                 (y-justify . center)
                 (class . title))

		((background . ,iconify-images)
      		 (top-edge . -22)
		 (right-edge . 37) 
		 (class . iconify-button))

                ((background . ,menu-images)
		 (top-edge . -22)
		 (left-edge . -3)
		 (class . menu-button))

     		((background . ,maximize-images)
      		 (top-edge . -22)
      		 (right-edge . 20)
      		 (class . maximize-button))

    		((background . ,close-images)
      		 (top-edge . -22)
      		 (right-edge . -3)
      		 (class . close-button))

     		((background . ,border-left)
      		 (top-edge . 0)
      		 (bottom-edge . 0)
      		 (left-edge . -3) 
      		 (class . left-border))

     		((background . ,border-right)
      		 (top-edge . 0)
      		 (bottom-edge . 0)
      		 (right-edge . -3)
      		 (class . right-border))

     		((background . ,border-bottom)
      		 (bottom-edge . -3)
      		 (right-edge . 0)  
      		 (left-edge . 0)   
      		 (class . bottom-border))

     		((background . ,corner-bl-1)
      		 (bottom-edge . -3)
      		 (left-edge . -3)  
      		 (class . bottom-left-corner))

     		((background . ,corner-br-1)
      		 (bottom-edge . -3)
      		 (right-edge . -3) 
      		 (class . bottom-right-corner))
	))

	(shaped-frame `(
      
     		((background . ,title-images)
      		 (top-edge . -22)
      		 (left-edge . 20)
      		 (right-edge . 53)
		 (foreground . ,font-colors)
		 (font . ,font)
		 (text . ,window-name)
                 (x-justify . center)
                 (y-justify . center)
      		 (class . title))

     		((background . ,iconify-images)
      		 (top-edge . -22)
      		 (right-edge . 37) 
      		 (class . iconify-button))

                ((background . ,menu-images)
		 (top-edge . -22)
		 (left-edge . -3)
		 (class . menu-button))

     		((background . ,maximize-images)
      		 (top-edge . -22)
      		 (right-edge . 20)
      		 (class . maximize-button))

     		((background . ,close-images)
      		 (top-edge . -22)
      		 (right-edge . -3)
      		 (class . close-button))
  
	))

	(transient-frame `(

		((background . ,title-images)
		 (top-edge . -22)
		 (left-edge . -3)
		 (right-edge . -3)
		 (foreground . ,font-colors)
		 (font . ,font)
		 (text . ,window-name)
                 (x-justify . center)
                 (y-justify . center)
		 (class . title))
		 
		((background . ,iconify-images)
      		 (top-edge . -22)
		 (right-edge . 20) 
		 (class . iconify-button))

                ((background . ,menu-images)
		 (top-edge . -22)
		 (left-edge . -3)
		 (class . menu-button))

    		((background . ,close-images)
      		 (top-edge . -22)
      		 (right-edge . -3)
      		 (class . close-button))

     		((background . ,border-left)
      		 (top-edge . 0)
      		 (bottom-edge . 0)
      		 (left-edge . -3) 
      		 (class . left-border))

     		((background . ,border-right)
      		 (top-edge . 0)
      		 (bottom-edge . 0)
      		 (right-edge . -3)
      		 (class . right-border))

     		((background . ,border-bottom)
      		 (bottom-edge . -3)
      		 (right-edge . 0)  
      		 (left-edge . 0)   
      		 (class . bottom-border))

     		((background . ,corner-bl-1)
      		 (bottom-edge . -3)
      		 (left-edge . -3)  
      		 (class . bottom-left-corner))

     		((background . ,corner-br-1)
      		 (bottom-edge . -3)
      		 (right-edge . -3) 
      		 (class . bottom-right-corner))

	))
	
	(shaped-transient-frame `(
      
     		((background . ,title-images)
      		 (top-edge . -22)
      		 (left-edge . -3)
      		 (right-edge . -3)
		 (foreground . ,font-colors)
		 (font . ,font)
		 (text . ,window-name)
                 (x-justify . center)
                 (y-justify . center)
      		 (class . title))
		 
     		((background . ,iconify-images)
      		 (top-edge . -22)
      		 (right-edge . 20) 
      		 (class . iconify-button))
		 
		((background . ,menu-images)
		 (top-edge . -22)
		 (left-edge . -3)
		 (class . menu-button))

     		((background . ,close-images)
      		 (top-edge . -22)
      		 (right-edge . -3)
      		 (class . close-button))

	))
	
  )
  (add-frame-style 'whistler-II
    	(lambda (w type)
	  (case type
	    ((default) frame)
	    ((transient) transient-frame)
	    ((shaped) shaped-frame)
	    ((shaped-transient) shaped-transient-frame))))
   
   
   (call-after-property-changed
     'WM_NAME (lambda ()
                (rebuild-frames-with-style 'whistler-II))))